import renderer from 'react-test-renderer';
import { renderToString } from 'fela-tools';
import felaTestContext from './felaTestContext';
import createRenderer from './createRenderer';
import cssbeautify from 'cssbeautify';
var options = {
  indent: '  ',
  openbrace: 'end-of-line',
  autosemicolon: false
};
export default (function (component) {
  var renderOptions = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var felaRenderer = createRenderer({
    dev: true
  });
  return {
    component: renderer.create(felaTestContext(component, felaRenderer), renderOptions).toJSON(),
    styles: "\n".concat(cssbeautify(renderToString(felaRenderer), options), "\n")
  };
});