import * as React from 'react';
import { IRenderer, IConfig } from 'fela';

export { IRenderer };

interface ICreateRendererOptions extends IConfig {
  dev?: boolean;
}

interface IStyleProviderProps {
  renderer?: IRenderer;
}

export class StyleProvider extends React.Component<
  React.PropsWithChildren<IStyleProviderProps & ICreateRendererOptions>,
  Object
> {}

export function createRenderer(options?: ICreateRendererOptions): IRenderer;

export const felaTestContext: (
  element: React.ReactElement,
  renderer?: IRenderer
) => React.ReactElement;

export function felaSnapshot(
  component: React.ReactElement
): {
  component: any;
  styles: string;
};
